/* Generated file, DO NOT edit! */

static char const* const _phong_fshader = 
   "#version 430 core\n"
   "uniform vec3 color;\n"
   "uniform vec3 globalLightIa, globalLightId, globalLightIs;\n"
   "uniform vec3 ka, kd, ks;\n"
   "uniform float p;\n"
   "// Input data\n"
   "in vec3 fragVertexPos;\n"
   "in vec3 lightDirection, viewDirection;\n"
   "in vec4 ShadowCoord;\n"
   " layout (location = 0) out vec4 FragColor;\n"
   " layout (location = 1) out vec4 BrightColor;\n"
   "// ShadowMap\n"
   "uniform sampler2DShadow shadowMap;\n"
   "// Ouput data\n"
   "out vec4 outColor;\n"
   "// Soft Shadows\n"
   "// @src: http://fabiensanglard.net/shadowmappingPCF/index.php\n"
   "float lookupShadow(vec2 offset, float bias) {\n"
   "    // Resolution of Shadowmap == 1 Pixel\n"
   "    float kernel = 1.0/1024.0;\n"
   "    // map coordiantes to texel space [0,1]\n"
   "    vec3 proj = (ShadowCoord.xyz/ShadowCoord.w) * 0.5 + vec3(0.5);\n"
   "    return texture(shadowMap, proj + vec3(offset.x*kernel, offset.y*kernel, bias));\n"
   "}\n"
   "float getShadow() {\n"
   "    float bias = -1e-6;\n"
   "    float visibility = 1.0;\n"
   "    float shadow = 0.0;\n"
   "    if (ShadowCoord.w > 1.0) {\n"
   "        float x = 0;\n"
   "        float y = 0;\n"
   "        for (y = -1.5 ; y <=1.5 ; y+=1.0) {\n"
   "            for (x = -1.5 ; x <=1.5 ; x+=1.0) {\n"
   "                shadow += lookupShadow(vec2(x,y),bias);\n"
   "            }\n"
   "        }\n"
   "        shadow /= 16.0 ;\n"
   "        shadow += 0.2;\n"
   "    }\n"
   "    return shadow;\n"
   "}\n"
   "void main(){\n"
   "    // Estimate the normal\n"
   "    vec3 X = dFdx(fragVertexPos);\n"
   "    vec3 Y = dFdy(fragVertexPos);\n"
   "    vec3 normal = normalize(cross(X, Y));\n"
   "    // compute ambient term\n"
   "    vec3 t_ambient = globalLightIa*ka*color;\n"
   "    // compute diffuse term\n"
   "    vec3 t_diffuse = globalLightId*kd*color*max(dot(normal, normalize(lightDirection)),0.0);\n"
   "    // compute specular term\n"
   "    vec3 R = normalize(2.0 * dot(normal, lightDirection)*normal - lightDirection);\n"
   "    vec3 t_specular = globalLightIs*ks*color * pow(max(dot(normalize(viewDirection), R), 0.0), p);\n"
   "    float visibility = getShadow();\n"
   "    outColor = vec4(t_ambient + t_diffuse + t_specular, 1.0);\n"
   "    // DEBUG visibility\n"
   "    // outColor = vec4(vec3(visibility), 1.0);\n"
   "     FragColor = outColor;\n"
   "     BrightColor = vec4(0,0,0,1);\n"
   "}\n"
   ;
