/* Generated file, DO NOT edit! */

static char const* const _terrain_fshader = 
   "#version 430 core\n"
   "uniform vec3 color;\n"
   "uniform vec3 globalLightPos,globalLightIa, globalLightId, globalLightIs;\n"
   "uniform vec3 ka, kd, ks;\n"
   "uniform vec3 camPos;\n"
   "uniform float p;\n"
   "uniform sampler2D snowTexture;\n"
   "uniform sampler2D rockTexture;\n"
   "uniform sampler2D landTexture;\n"
   "uniform sampler2D woodTexture;\n"
   "uniform sampler2D sandTexture;\n"
   "// ShadowMap\n"
   "uniform sampler2DShadow shadowMap;\n"
   "uniform uint featureTextures;\n"
   "uniform uint featureSteepTextures;\n"
   "uniform uint featureShadows;\n"
   "uniform uint featureSmoothShadows;\n"
   "uniform uint debugSlope;\n"
   "uniform uint debugDisplacement;\n"
   "uniform uint debugVisibility;\n"
   "layout (location = 0) out vec4 FragColor;\n"
   "layout (location = 1) out vec4 BrightColor;\n"
   "// Input data\n"
   "in float displacement;\n"
   "in vec2 fragUV;\n"
   "in vec3 fragVertexPos, fragVertexPosMW;\n"
   "in vec3 fragNormal, fragNormalMW,fragNormalM;\n"
   "in vec3 lightDirection, viewDirection;\n"
   "in vec4 ShadowCoord;\n"
   "in vec4 oLightPosM;\n"
   "out vec4 outColor;\n"
   "// Soft Shadows\n"
   "// @src: http://www.learnopengl.com/#!Advanced-Lighting/Shadows/Shadow-Mapping\n"
   "float simpleShadow(vec3 offset, float bias) {\n"
   "    // Resolution of Shadowmap == 1 Pixel\n"
   "    float kernel = 1.0/1024.0;\n"
   "    // map coordiantes to texel space [0,1]\n"
   "    //vec3 proj = (ShadowCoord.xyz/ShadowCoord.w) * 0.5 + vec3(0.5);\n"
   "    //return textureProj(shadowMap, proj /* + vec3(offset.x*kernel, offset.y*kernel, bias) */);\n"
   "    //vec4 s = ShadowCoord*0.5 +  + vec4(0.5);\n"
   "    //return shadow2DProj(shadowMap,ShadowCoord+vec4(offset.x*kernel*ShadowCoord.w, offset.y*kernel*ShadowCoord.w, bias,0)).w;\n"
   "   // perform perspective divide\n"
   "    vec3 projCoords = ShadowCoord.xyz / ShadowCoord.w;\n"
   "    // Transform to [0,1] range\n"
   "    projCoords = projCoords * 0.5 + vec3(0.5);\n"
   "    // Get closest depth value from light's perspective (using [0,1] range fragPosLight as coords)\n"
   "    vec3 coords = projCoords.xyz;\n"
   "    float closestDepth = texture(shadowMap, coords + offset * kernel).r; \n"
   "    // Get depth of current fragment from light's perspective\n"
   "    float currentDepth = projCoords.z;\n"
   "    // Check whether current frag pos is in shadow\n"
   "    float shadow = currentDepth - bias > closestDepth  ? 1.0 : 0.0;\n"
   "    return shadow;\n"
   "}\n"
   "float smoothShadow(vec3 normal, vec3 lightDir) {\n"
   "    float bias = max(0.85 * (1.0 - dot(normal, lightDir)), 0.005);\n"
   "    float visibility = 1.0;\n"
   "    float shadow = 0.0;\n"
   "    if (ShadowCoord.w > 1.0) {\n"
   "        float x = 0;\n"
   "        float y = 0;\n"
   "        for (y = -1.0 ; y <=1.0 ; y+=1.0) {\n"
   "            for (x = -1.0 ; x <=1.0 ; x+=1.0) {\n"
   "                shadow += simpleShadow(vec3(x,y,0),bias);\n"
   "            }\n"
   "        }\n"
   "        shadow /= 9.0 ;\n"
   "        //shadow += 0.2;\n"
   "    }\n"
   "    return shadow;\n"
   "}\n"
   "float scale(float _val, float _min, float _max) {\n"
   "  return clamp(abs((_val - _min) / (_max - _min)), 0, 1);\n"
   "}\n"
   "void main() {\n"
   "    vec3 fragColor = color;\n"
   "    float slope = 1.0 - abs(dot(fragNormal, vec3(0.0, 0.0, 1.0)));\n"
   "    float rockStep = smoothstep(0.3, 0.35, slope);\n"
   "    float snowFreq = 10.0;\n"
   "    vec3 snowColor = texture(snowTexture, fragUV*snowFreq).xyz;\n"
   "    float snowLimit = 0.8;\n"
   "    float rockFreq = 20.0;\n"
   "    vec3 rockColor = texture(rockTexture, fragUV*rockFreq).xyz;\n"
   "    float rockLimit = snowLimit - 0.2;\n"
   "    float landFreq = 30.0;\n"
   "    vec3 landColor = texture(landTexture, fragUV*landFreq).xyz;\n"
   "    float landLimit = rockLimit - 0.2;\n"
   "    float woodFreq = 30.0;\n"
   "    vec3 woodColor = texture(woodTexture, fragUV*woodFreq).xyz;\n"
   "    float woodLimit = landLimit - 0.2;\n"
   "    float sandFreq = 30.0;\n"
   "    vec3 sandColor = texture(sandTexture, fragUV*sandFreq).xyz;\n"
   "    float sandLimit = woodLimit - 0.2;\n"
   "    if (featureTextures == 1) {\n"
   "        if (displacement > snowLimit) {\n"
   "          fragColor = snowColor;\n"
   "        }\n"
   "        else if (displacement > rockLimit) {\n"
   "          fragColor = mix(rockColor, snowColor, scale(displacement, rockLimit, snowLimit));\n"
   "        }\n"
   "        else if (displacement > landLimit) {\n"
   "          fragColor = mix(landColor, rockColor, scale(displacement, landLimit, rockLimit));\n"
   "        }\n"
   "        else if (displacement > woodLimit) {\n"
   "          fragColor = mix(woodColor, landColor, scale(displacement, woodLimit, landLimit));\n"
   "        }\n"
   "        else {\n"
   "          fragColor = sandColor;\n"
   "        }\n"
   "        if (featureSteepTextures == 1) {\n"
   "            // Rocks, when too steep\n"
   "            fragColor = mix(fragColor, rockColor, rockStep);\n"
   "        }\n"
   "    }\n"
   "    // compute ambient term\n"
   "    vec3 t_ambient = globalLightIa*ka*fragColor;\n"
   "    \n"
   "    vec3 lightDir = normalize(globalLightPos-fragVertexPos);\n"
   "    // compute diffuse term\n"
   "    //vec3 t_diffuse = globalLightId*kd*fragColor*max(dot(fragNormal, normalize(lightDirection)),0.0);\n"
   "    vec3 t_diffuse = globalLightId*kd*fragColor*max(dot(fragNormalM, lightDir),0.0);\n"
   "    // compute specular term\n"
   "    //vec3 R = normalize(2.0 * dot(fragNormal, lightDirection)*fragNormal - lightDirection);\n"
   "    //vec3 t_specular = globalLightIs*ks*fragColor * pow(max(dot(normalize(viewDirection), R), 0.0), p);\n"
   "    \n"
   "    vec3 R = normalize(2.0 * dot(fragNormalM, lightDir)*fragNormalM - lightDir);\n"
   "    vec3 t_specular = globalLightIs*ks*fragColor*pow(max(dot(normalize(camPos-fragVertexPos), R), 0.0), p);\n"
   "    float visibility = 1.0;\n"
   "    if (featureShadows == 1){\n"
   "        visibility = simpleShadow(vec3(0.0), 1e-6);\n"
   "        if (featureSmoothShadows == 1){\n"
   "            visibility = 1.0 - smoothShadow(fragNormalM,lightDir);\n"
   "        }\n"
   "    }\n"
   "    outColor = vec4(t_ambient + t_diffuse *visibility + t_specular*visibility, 1.0);\n"
   "    \n"
   "    if (debugVisibility == 1) {\n"
   "        // DEBUG visibility\n"
   "        outColor = vec4(vec3(visibility), 1.0);\n"
   "    }\n"
   "    // outColor = vec4(vec3(lookupShadow(vec2(0.0), 0.0), 1.0, 0.0), 1.0);\n"
   "    // DEBUG texture\n"
   "    // outColor = vec4(fragColor, 1.0);\n"
   "    if (debugSlope == 1) {\n"
   "        // DEBUG slope\n"
   "        outColor = vec4(vec3(slope), 1.0);\n"
   "    }\n"
   "    if (debugDisplacement == 1) {\n"
   "        // DEBUG displacement\n"
   "        outColor = vec4(vec3(displacement),1.0);\n"
   "    }\n"
   "     FragColor = outColor;\n"
   "     BrightColor = vec4(0,0,0,1);\n"
   "}\n"
   ;
