/* Generated file, DO NOT edit! */

static char const* const _water_fshader = 
   "#version 430 core\n"
   "uniform vec3 color;\n"
   "uniform vec3 globalLightPos;\n"
   "uniform vec3 globalLightIa, globalLightId, globalLightIs;\n"
   "uniform vec3 ka, kd, ks;\n"
   "uniform vec3 camPos;\n"
   "uniform float p;\n"
   "uniform float time;\n"
   "uniform sampler2D wavesMap;\n"
   "uniform samplerCube cubeSampler;\n"
   "uniform sampler2D refractionObjects;\n"
   "uniform mat4 model, view;\n"
   "uniform uint featureShadows;\n"
   "uniform uint featureSmoothShadows;\n"
   "uniform uint featureReflection;\n"
   "uniform uint debugVisibility;\n"
   "uniform uint debugNormals;\n"
   "uniform uint debugReflection;\n"
   "layout (location = 0) out vec4 FragColor;\n"
   "layout (location = 1) out vec4 BrightColor;\n"
   "// Input data\n"
   "in vec2 fragUV;\n"
   "in vec3 fragVertexPos;\n"
   "in vec3 fragNormal;\n"
   "in vec3 fragNormalMV,fragNormalM;\n"
   "in vec3 lightDirection, viewDirection;\n"
   "in vec4 ShadowCoord;\n"
   "in vec4 oLightPosM;\n"
   "in mat3 TBN;\n"
   "// ShadowMap\n"
   "uniform sampler2DShadow shadowMap;\n"
   "// Ouput data\n"
   "out vec4 outColor;\n"
   "// Soft Shadows\n"
   "// @src: http://www.learnopengl.com/#!Advanced-Lighting/Shadows/Shadow-Mapping\n"
   "float simpleShadow(vec3 offset, float bias) {\n"
   "    // Resolution of Shadowmap == 1 Pixel\n"
   "    float kernel = 1.0/1024.0;\n"
   "    // map coordiantes to texel space [0,1]\n"
   "    //vec3 proj = (ShadowCoord.xyz/ShadowCoord.w) * 0.5 + vec3(0.5);\n"
   "    //return textureProj(shadowMap, proj /* + vec3(offset.x*kernel, offset.y*kernel, bias) */);\n"
   "    //vec4 s = ShadowCoord*0.5 +  + vec4(0.5);\n"
   "    //return shadow2DProj(shadowMap,ShadowCoord+vec4(offset.x*kernel*ShadowCoord.w, offset.y*kernel*ShadowCoord.w, bias,0)).w;\n"
   "   // perform perspective divide\n"
   "    vec3 projCoords = ShadowCoord.xyz / ShadowCoord.w;\n"
   "    // Transform to [0,1] range\n"
   "    projCoords = projCoords * 0.5 + vec3(0.5);\n"
   "    // Get closest depth value from light's perspective (using [0,1] range fragPosLight as coords)\n"
   "    vec3 coords = projCoords.xyz;\n"
   "    float closestDepth = texture(shadowMap, coords + offset * kernel).r; \n"
   "    // Get depth of current fragment from light's perspective\n"
   "    float currentDepth = projCoords.z;\n"
   "    // Check whether current frag pos is in shadow\n"
   "    float shadow = currentDepth - bias > closestDepth  ? 1.0 : 0.0;\n"
   "    return shadow;\n"
   "}\n"
   "float smoothShadow(vec3 normal, vec3 lightDir) {\n"
   "    float bias = max(0.9 * (1.0 - dot(normal, lightDir)), 0.05);\n"
   "    float shadow = 0.0;\n"
   "    if (ShadowCoord.w > 1.0) {\n"
   "        float x = 0;\n"
   "        float y = 0;\n"
   "        for (y = -1.0 ; y <=1.0 ; y+=1.0) {\n"
   "            for (x = -1.0 ; x <=1.0 ; x+=1.0) {\n"
   "                shadow += simpleShadow(vec3(x,y,0),bias);\n"
   "            }\n"
   "        }\n"
   "        shadow /= 9.0 ;\n"
   "        //shadow += 0.2;\n"
   "    }\n"
   "    return shadow;\n"
   "}\n"
   "void main(){\n"
   "    vec3 fragColor = color;\n"
   "    vec3 reflectColor = vec3(0.0,0.0,0.0);\n"
   "    \n"
   "    float waveFreq = 20.0;\n"
   "    float waveAmpl = 0.5;\n"
   "    \n"
   "   vec3 normal = texture(wavesMap, fragUV*waveFreq + time*0.05).xyz;\n"
   "   // map from texel [0,1] to vector [-1,1] range\n"
   "   normal = normalize(normal *2.0 -1.0);\n"
   "   normal = normalize(TBN * normal); \n"
   "   //vec3 normal_r =  vec3(0,1,0);\n"
   "   //normal = transpose(inverse(mat3(model))) * normal;\n"
   "   //normal_r = normalize(normal_r);\n"
   "   \n"
   "   //normal = normal_r;\n"
   "    if (featureReflection == 1){\n"
   "        float air_to_water_fresnel = 1.00 / 1.52;\n"
   "        vec3 I = normalize(camPos-fragVertexPos);\n"
   "        vec3 R = reflect(I, normal);\n"
   "        reflectColor = texture(cubeSampler, R).xyz;\n"
   "        fragColor = reflectColor;\n"
   "    }\n"
   "    //vec2 wavesSample = waveAmpl * texture(wavesMap, fragUV * waveFreq + 0.05).xy;\n"
   "    //vec4 refractColor = texture(refractionObjects,(I.xy*2)-1) + vec4(0.2,0,0,0);\n"
   "    \n"
   "    vec3 lightDir = normalize(globalLightPos- fragVertexPos);\n"
   "    // compute ambient term\n"
   "    vec3 t_ambient = 3*(globalLightIa*ka)*fragColor / 4;\n"
   "    // compute diffuse term\n"
   "    //vec3 t_diffuse = globalLightId*kd*fragColor*max(dot(fragNormalMV, normalize(lightDirection)),0.0);\n"
   "    vec3 t_diffuse = globalLightId*kd*fragColor*max(dot(normal,lightDir),0.0);\n"
   "    // compute specular term\n"
   "    //vec3 R = normalize(2.0 * dot(fragNormalMV, lightDirection)*fragNormalMV - lightDirection);\n"
   "    //vec3 t_specular = globalLightIs*ks*fragColor * pow(max(dot(normalize(viewDirection), R), 0.0), p);\n"
   "    \n"
   "    vec3 R = normalize(2.0 * dot(normal, lightDir)*normal - lightDir);\n"
   "    vec3 t_specular = globalLightIs*ks*fragColor*pow(max(dot(normalize(camPos-fragVertexPos), R), 0.0), p);\n"
   "    float visibility = 1.0;\n"
   "    if (featureShadows == 1){\n"
   "        visibility = simpleShadow(vec3(0.0), 1e-6);\n"
   "        if (featureSmoothShadows == 1){\n"
   "            visibility = 1.0 - smoothShadow(normal,lightDir);\n"
   "        }\n"
   "    }\n"
   "   \n"
   "    outColor = vec4(t_ambient +  t_diffuse  *visibility + t_specular*visibility, 1.0);\n"
   "    \n"
   "    //outColor = vec4(normal_r,1.0);\n"
   "    if (debugReflection == 1) {\n"
   "        // DEBUG Reflection\n"
   "        outColor = vec4(reflectColor, 1.0);\n"
   "    }\n"
   "    if (debugNormals == 1){\n"
   "        // DEBUG normalmap\n"
   "        outColor = vec4(fragNormalMV, 1.0);\n"
   "    }\n"
   "    // DEBUG t_ambient\n"
   "    // outColor = vec4(t_ambient, 1.0);\n"
   "    if (debugVisibility == 1){\n"
   "        // DEBUG visibility\n"
   "        outColor = vec4(vec3(visibility), 1.0);\n"
   "    }\n"
   "    //FragColor = vec4(TBN[1],1.0);\n"
   "    \n"
   "    //FragColor = vec4(view[1][0],view[1][1],view[1][2],1.0);\n"
   "    \n"
   "    FragColor = outColor;\n"
   "    float brightness = dot(outColor.xyz, vec3(0.2126, 0.5152, 0.0722));\n"
   "    if(brightness > 0.6) {\n"
   "        BrightColor =  outColor;\n"
   "    }\n"
   "    else {\n"
   "        BrightColor = vec4(0,0,0,1);\n"
   "    }\n"
   "}\n"
   ;
